/*

        daytime.c

        KipTOOLS - (C) Angel Ortega

*/

#include <stdio.h>

#include "kiptools.h"


void exiterror(char * msg, int val)
{
        end_sockets();

        printf("%s: %s\n",msg, strerrorsocket());
        exit(val);
}


int main(int argc, char * argv[])
{
        int stype;
        int s;
        struct hostent * h;
        struct sockaddr_in server;
        char str[1024];
        int l;

        printf("Daytime client - %s\n",KIPTOOLS_VERSION);
        printf("  (C) Angel Ortega 1995/1997\n\n");

        if(argc!=3)
        {
                printf("Usage: daytime u|t {ip}\n\n");
                printf("u - UDP connection.\n");
                printf("t - TCP connection.\n");

                exit(1);
        }

        if(!init_sockets())
                exiterror("init_sockets",2);

        /* transforma el IP */
        if((h=gethostbyname(argv[2]))==NULL)
        {
                printf("Error: host '%s' not found.\n", argv[2]);
                exiterror("gethostbyname",2);
        }

        memcpy((char *)&server.sin_addr,(char *)h->h_addr,h->h_length);

        /* calcula el tipo de socket */
        if(argv[1][0]=='u' || argv[1][0]=='U')
        {
                printf("UDP connection:\n");
                stype=SOCK_DGRAM;
        }
        else
        {
                printf("TCP connection:\n");
                stype=SOCK_STREAM;
        }

        /* rellena la familia y el puerto destino */
        server.sin_family=AF_INET;
        server.sin_port=htons(13);

        /* pide un socket */
        if((s=socket(AF_INET, stype, 0))==-1)
                exiterror("socket",3);

        /* hace la conexin con el server (en el caso de UDP,
           slo para hacer el ARP) */
        if((connect(s,(struct sockaddr *)&server,sizeof(server)))==-1)
                exiterror("connect",4);

        /* enva algo por el puerto */
        if((send(s,"KIP",3,0))==-1)
                exiterror("send",5);

        /* espera la respuesta */
        if((l=recv(s,str,sizeof(str)-1,0))==-1)
                exiterror("recv",6);

        str[l]=0;
        printf("%s",str);

        /* cierra el socket */
        if(closesocket(s)==-1)
                exiterror("close",7);

        end_sockets();

        return(0);
}
