/*

        finger.c

        KipTOOLS - (C) Angel Ortega

*/

#include <string.h>

#include "kiptools.h"


void exiterror(char * msg, int val)
{
        end_sockets();

        printf("%s: %s\n",msg, strerrorsocket());
        exit(val);
}


int main(int argc, char * argv[])
{
        int s;
        struct hostent * h;
        struct sockaddr_in server;
        char str[4096];
        int l;
        char * username;
        char * hostname;

        printf("Finger - %s\n", KIPTOOLS_VERSION);
        printf("  (C) Angel Ortega 1995/1997\n\n");

        if(argc<2)
        {
                printf("Usage: finger [user@]host\n");

                exit(1);
        }

        if(!init_sockets())
                exiterror("init_sockets",2);

        /* extrae el usuario y el host */
        if((hostname=strchr(argv[1],'@'))==NULL)
        {
                hostname=argv[1];
                username="";
        }
        else
        {
                *hostname='\0';
                hostname++;
                username=argv[1];
        }

        /* transforma el IP */
        if((h=gethostbyname(hostname))==NULL)
        {
                printf("Error: host '%s' not found.\n", hostname);
                exiterror("gethostbyname",2);
        }

        memcpy((char *)&server.sin_addr,(char *)h->h_addr,h->h_length);
        server.sin_family=h->h_addrtype;
        server.sin_port=htons(79);

        /* pide un socket */
        if((s=socket(AF_INET, SOCK_STREAM, 0))==-1)
                exiterror("socket",3);

        if((connect(s,(struct sockaddr *)&server,sizeof(server)))==-1)
                exiterror("connect",4);

        sprintf(str,"%s\r\n",username);

        if(send(s,str,strlen(str),0)==-1)
                exiterror("send",5);

        /* espera la respuesta */
        for(;;)
        {
                if((l=recv(s,str,sizeof(str)-1,0))<=0)
                        break;

                str[l]=0;
                printf(str);
        }

        /* cierra el socket */
        if(closesocket(s)==-1)
                exiterror("close",7);

        end_sockets();

        return(0);
}
