/*

        kiptools.h

        KipTOOLS header file - (C) Angel Ortega 1997/1998

*/

#if defined(__TURBOC__)
        #define KIP
        #undef STD_SOCKETS
	#undef CAN_FORK

#elif defined(DJGPP)
        #undef KIP
        #undef STD_SOCKETS
	#undef CAN_FORK

#elif defined(__LCC__)
        #undef KIP
        #undef STD_SOCKETS
	#undef CAN_FORK

#else
        #undef KIP
        #define STD_SOCKETS
	#define CAN_FORK
#endif

#if defined(KIP)
        #include "../kip/kip.h"

        #define init_sockets InitKIP
        #define end_sockets  EndKIP

        #define KIPTOOLS_VERSION "KipTOOLS (tcc+kip)"
#endif /* KIP */

#if defined(STD_SOCKETS)
        #include <sys/socket.h>
        #include <netinet/in.h>
        #include <netdb.h>
        #include <errno.h>

        #define __close     close
        #define sclose      close
        #define closesocket close

        #define __ioctl     ioctl
        #define sioctl      ioctl
        #define ioctlsocket ioctl

        #define init_sockets() (1)
        #define end_sockets()
        #define strerrorsocket() strerror(errno)

        #define O_BINARY 0

        #if defined(__CYGWIN32__)
                #define KIPTOOLS_VERSION "KipTOOLS (cygwin32)"
        #elif defined(linux)
                #define KIPTOOLS_VERSION "KipTOOLS (linux)"
        #else
                #define KIPTOOLS_VERSION "KipTOOLS (std sockets)"
        #endif
#endif /* STD_SOCKETS */

#if defined(DJGPP)

        #include "../kipdj/kipdj.h"

        #define init_sockets() _kipdj_startup()
        #define end_sockets()

        #define KIPTOOLS_VERSION "KipTOOLS (djgpp+kipdj)"

#endif /* ifdef DJGPP */

#ifdef __LCC__

        #include <winsock.h>

        WSADATA wsadata;

        #define init_sockets() !(WSAStartup(0x0101,&wsadata))
        #define end_sockets() WSACleanup()
        #define getlogin() "user"
        #define strerrorsocket() "lcc/winsock error"

        #define KIPTOOLS_VERSION "KipTOOLS (lcc_win32)"

#endif /* LCC */
