/*

        myip.c

        KipTOOLS - (C) Angel Ortega

*/

#include <string.h>

#include "kiptools.h"

/* IP de un server al que conectarse (es www.internic.net) */
char SERVER_IP[100]="198.41.0.6";

/* puerto */
int _server_port=80;


void exiterror(char * msg, int val)
{
        end_sockets();

        printf("%s: %s\n",msg, strerrorsocket());
        exit(val);
}


int main(int argc, char * argv[])
{
        int s;
        struct sockaddr_in sin;
        int n;

        if(argc>1)
                strcpy(SERVER_IP,argv[1]);

        if(argc>2)
                _server_port=atoi(argv[2]);

        printf("MyIP - %s\n", KIPTOOLS_VERSION);
        printf("  (C) Angel Ortega 1998\n\n");

        if(!init_sockets())
                exiterror("init_sockets",2);

        /* pide un socket */
        if((s=socket(AF_INET, SOCK_STREAM, 0))==-1)
                exiterror("socket",3);

        sin.sin_addr.s_addr=inet_addr(SERVER_IP);
        sin.sin_family=AF_INET;
        sin.sin_port=htons(_server_port);

        if((connect(s,(struct sockaddr *)&sin,sizeof(sin)))==-1)
                exiterror("connect",4);

        n=sizeof(sin);
        if(getsockname(s,(struct sockaddr *)&sin,&n)==-1)
                exiterror("getsockname",4);

        printf("My IP: %s (through %s:%d)\n",
/*                inet_ntoa((struct in_addr) sin.sin_addr),*/
                inet_ntoa(sin.sin_addr),
                SERVER_IP,_server_port);

        closesocket(s);

        end_sockets();

        return(0);
}
