/*

        nanotel.c

        KipTOOLS - (C) Angel Ortega

*/

#include "kiptools.h"


/* puerto por defecto */

#define TELNET_PORT 23

int telnet_port=TELNET_PORT;


/* eco local */

int local_echo=0;


/* cadena de inicializacin */

char * telnet_init="\377\375\001\377\375\003\377\374\030";
//char * telnet_init="\xff\xfd\x03\xff\xfb\x18\xff\xfb\x1f\xff\xfb\x20\xff\xfb\x21\xff\xfb\x22\xff\xfb\x24\xff\xfd\x05\xff\xfb\x23";

void exiterror(char * msg, int val)
{
        end_sockets();

        printf("%s: %s\n",msg, strerrorsocket());
        exit(val);
}


int main(int argc, char * argv[])
{
        int stype;
        int s;
        struct hostent * h;
        struct sockaddr_in server;
        int l,n;
        long blocking;
        unsigned char c;
        unsigned char str[4096];

        printf("Nanotel (Nano Telnet) - %s\n",KIPTOOLS_VERSION);
        printf("  (C) Angel Ortega 1995/1997.\n\n");

        if(argc<2)
        {
                printf("Usage: nanotel {host} [{port}]\n\n");

                exit(1);
        }

        if(argc>2)
                telnet_port=atoi(argv[2]);

        if(!init_sockets())
                exiterror("init",2);

        /* transforma el IP */
        if((h=gethostbyname(argv[1]))==NULL)
        {
                printf("Error: host '%s' not found.\n", argv[1]);
                exiterror("gethostbyname",2);
        }

        memcpy((char *)&server.sin_addr,(char *)h->h_addr,h->h_length);
        server.sin_family=h->h_addrtype;
        server.sin_port=htons(telnet_port);

        /* pide un socket */
        if((s=socket(AF_INET, SOCK_STREAM, 0))==-1)
                exiterror("socket",3);

        /* conecta */
        if((connect(s,&server,sizeof(server)))==-1)
                exiterror("connect",4);

        /* define el socket como no bloqueante */
        blocking=0;

        ioctlsocket(s, FIONBIO, &blocking);

        /* enva la cadena de inicializacin del telnet */
        if(telnet_port==TELNET_PORT)
                send(s, telnet_init,sizeof(telnet_init)-1,0);
        else
                local_echo=1;

        /* comunica */
        for(;;)
        {
                if(kbhit())
                {
                        c=(unsigned char) getch();

                        if(c==1)
                                break;

                        if(c=='\r')
                        {
                                str[0]='\r';
                                str[1]='\n';
                                n=2;
                        }
                        else
                        {
                                str[0]=c;
                                n=1;
                        }

                        str[n]='\0';

                        if(send(s,str,n,0)==-1)
                                printf("*");

                        if(local_echo)
                                printf(str);
                }

                if((l=recv(s,str,sizeof(str)-1,0))==-1)
                {
                        if(KipErrno!=KIPERR_WOULDBLOCK)
                                break;
                }
                else
                {
                        for(n=0;n<l;n++)
                        {
//                                if(str[n]<128)
                                        putch(str[n]);
                        }
                }

                delay(30);
        }

        /* cierra el socket */
        if(closesocket(s)==-1)
                exiterror("close",7);

        EndKIP();
        return(0);
}
