/*

        nanoweb.c

        KipTOOLS

*/

#include <stdio.h>
#include <string.h>

#include "kiptools.h"


/* io buffer */
char buffer[512];

/* root directory for the web server */
char wwwroot[100]=".";

/* default port */
int wwwport=80;

/* file */
char file[200];


/******************
        code
*******************/

void exiterror(char * msg, int val)
{
        end_sockets();

        printf("%s: %s\n",msg, strerrorsocket());
        exit(val);
}


void http_get(int c)
{
        int n;
        int size;
        FILE * f;

        /* es una peticin de fichero */
        for(n=4;buffer[n]!=' ' && buffer[n]!='\0' &&
                buffer[n]!='\r' && buffer[n]!='\n';n++);
                        buffer[n]='\0';

        if(strcmp(&buffer[4],"/")==0)
                strcpy(&buffer[4],"/index.html");

        sprintf(file,"%s%s",wwwroot,&buffer[4]);

        if((f=fopen(file,"rb"))==NULL)
        {
                printf("GET: file '%s' not found\n",file);

                sprintf(buffer,"HTTP/1.0 404\n"
                        "Content-type: text/html\n\n"
                        "<html><body>\n"
                        "<h1>nanoweb - %s</h1>\n"
                        "<h2>(C) Angel Ortega 1995/1999</h2>\n"
                        "File not found.<p></body></html>\n",
                        KIPTOOLS_VERSION);

                send(c,buffer,strlen(buffer),0);
        }
        else
        {
                printf("GET: sending file '%s'\n",file);

                strcpy(buffer,"HTTP/1.0 200\nContent-type: text/html\n\n");

                for(;;)
                {
                        size=fread(buffer,1,sizeof(buffer),f);

                        if(size<=0)
                                break;

                        send(c,buffer,size,0);
                }

                fclose(f);
        }
}


int main(int argc, char * argv[])
{
        int s,c;
        struct sockaddr_in server;
        struct sockaddr_in client;
        int size;

        printf("nanoweb (Nano Web Server) - %s\n", KIPTOOLS_VERSION);
        printf("  (C) Angel Ortega 1995/1999\n\n");

        if(argc>1)
                strcpy(wwwroot,argv[1]);

        if(argc>2)
                wwwport=atoi(argv[2]);

        if(!init_sockets())
                exiterror("init",1);

        memset(&server,'\0',sizeof(server));
        server.sin_family=AF_INET;
        server.sin_port=htons(wwwport);

        if((s=socket(AF_INET,SOCK_STREAM,0))==-1)
                exiterror("socket",2);

        if(bind(s,(struct sockaddr *)&server,sizeof(server))==-1)
                exiterror("bind",3);

        getsockname(s,(struct sockaddr *)&server,&size);
        printf("[%s:%d]\n",inet_ntoa(server.sin_addr),
                ntohs(server.sin_port));

        listen(s,5);

        for(;;)
        {
                size=sizeof(struct sockaddr);

                if((c=accept(s,(struct sockaddr *)&client,&size))==-1)
                        exiterror("accept",5);

#ifdef CAN_FORK
                if(fork()!=0)
                {
#endif
                        if((size=recv(c,buffer,sizeof(buffer),0))<=0)
                                exiterror("recv",6);

                        buffer[size]='\0';

                        if(memcmp(buffer,"GET ",4)==0)
                                http_get(c);
#ifdef CAN_FORK

                        closesocket(c);
                        exit(0);
                }
#endif

                closesocket(c);
        }

        closesocket(s);

        end_sockets();

        return(0);
}
