/*

        pop.c

        Librera KIP.

        (C) Angel Ortega

*/

#include "kip.h"

void exiterror(char * msg, int val)
{
        EndKIP();

        printf("%s: %s\n",msg, StrErrorKIP());
        exit(val);
}

int main(int argc, char * argv[])
{
        int stype;
        int s;
        struct hostent * h;
        struct sockaddr_in server;
        char str[4096];
        int l;

        printf("Pop - Librera KIP.\n");
        printf("  (C) Angel Ortega 1995/1996.\n\n");

        if(argc!=2)
        {
                printf("Uso: pop {host}\n\n");

                exit(1);
        }

        if(!InitKIP())
                exiterror("InitKIP",2);

        /* transforma el IP */
        if((h=gethostbyname(argv[1]))==NULL)
        {
                printf("Error: host '%s' no encontrado.\n", argv[1]);
                exiterror("GetHostByName",2);
        }

        memcpy((char *)&server.sin_addr,(char *)h->h_addr,h->h_length);

        /* rellena la familia y el puerto destino */
        server.sin_family=AF_INET;
        server.sin_port=htons(110); //109

        /* pide un socket */
        if((s=socket(AF_INET, SOCK_STREAM, 0))==-1)
                exiterror("Socket",3);

        /* hace la conexin con el server */
        if((connect(s,&server,sizeof(server)))==-1)
                exiterror("ConnectSocket",4);

        for(;;)
        {
                /* espera la respuesta */
                if((l=recv(s,str,sizeof(str)-1,0))==-1)
                        break;

                str[l]=0;
                printf("%s",str);

                printf("pop> ");
                gets(str);
                if(str[0]!=0)
                        strcat(str,"\r\n");

                if(send(s,str,strlen(str),0)==-1)
                        break;
        }

        if(kbhit())
                getch();

        /* cierra el socket */
        if(closesocket(s)==-1)
                exiterror("CloseSocket",7);

        EndKIP();
        return(0);
}
