/*

        rcp.c

        KipTOOLS - (C) Angel Ortega

*/

#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
/*#include <io.h>*/
#include <sys/stat.h>
#include <time.h>

#include "kiptools.h"

void exiterror(char * msg, int val)
{
        end_sockets();

        printf("%s: %s\n",msg, strerrorsocket());
        exit(val);
}


int buildcmd(char * buf, char * name, char * cmd)
/* construye el comando RSH sobre buf */
/* devuelve la longitud */
{
        strcpy(buf,"0");
        buf+=2;
        strcpy(buf,name);
        buf+=strlen(name)+1;
        strcpy(buf,name);
        buf+=strlen(name)+1;
        strcpy(buf,cmd);

        return(5+strlen(name)*2+strlen(cmd));
}


void Aspa(void)
/* pinta un aspa */
{
        static int n=0;
        static char * aspa="/-\\|";

        printf("%c\r",aspa[n++]);
        n%=4;
}


int main(int argc, char * argv[])
{
        int s;
        struct hostent * h;
        struct sockaddr_in local;
        struct sockaddr_in server;
        static char str[1024];
        char cmd[300];
        int cmdlen;
        int l;
        char * username;
        char * hostname;
        char localname[80];
        char * lfile;
        char * rfile;
        int to;
        int fdes;
        long tot=0;

        /* logo */
        printf("\nRCP (Remote Copy) - %s\n",KIPTOOLS_VERSION);
        printf("  (C) Angel Ortega 1995/1997\n\n");

        if(argc!=3)
        {
                printf("Usage: RCP {source file} {destination file}\n\n");
                printf("One and only one of the files is [user@]host=file\n\n");
                printf("Examples:\n\n");
                printf("rcp root@dunwich=/etc/passwd c:\\hack\\passwd.dun\n");
                printf("rcp c:\\hack\\passwd.mod root@dunwich=/etc/passwd\n");
                printf("rcp c:\\autoexec.bat \"root@dunwich=|lpr\"\n");
                exit(0);
        }

        rfile=strchr(argv[1], '=');

        if(rfile!=NULL)
        {
                *rfile='\0';
                rfile++;

                lfile=argv[2];

                /* separa username de host */
                if((hostname=strchr(argv[1],'@'))==NULL)
                {
                        hostname=argv[1];
                        username=(char *)getlogin();
                }
                else
                {
                        *hostname='\0';
                        hostname++;

                        username=argv[1];
                }

                /* es hacia aqu */
                to=0;

                if((fdes=open(lfile,O_CREAT|O_TRUNC|O_WRONLY|O_BINARY,
                        S_IREAD|S_IWRITE))==-1)
                        exiterror("Error creating destination file.",20);
        }
        else
        {
                rfile=strchr(argv[2], '=');

                if(rfile!=NULL)
                {
                        *rfile=0;
                        rfile++;

                        lfile=argv[1];

                        /* separa username de host */
                        if((hostname=strchr(argv[2],'@'))==NULL)
                        {
                                hostname=argv[2];
                                username=(char *)getlogin();
                        }
                        else
                        {
                                *hostname='\0';
                                hostname++;

                                username=argv[2];
                        }

                        /* es hacia all */
                        to=1;

                        if((fdes=open(lfile,O_RDONLY|O_BINARY))==-1)
                                exiterror("Error opening source.",30);
                }
                else
                {
                        printf("No remote files? Use COPY instead.\n");
                        exiterror("Bad arguments", 1);
                }
        }

        if(!init_sockets())
                exiterror("init",2);

        /* transforma el IP */
        if((h=gethostbyname(hostname))==NULL)
        {
                printf("Error: host '%s' not found.\n", hostname);
                exiterror("gethostbyname",2);
        }

        memcpy((char *)&server.sin_addr,(char *)h->h_addr,h->h_length);

        /* rellena la familia y el puerto destino */
        server.sin_family=AF_INET;
        server.sin_port=htons(514);

        /* pide un socket */
        if((s=socket(AF_INET, SOCK_STREAM, 0))==-1)
                exiterror("socket",3);

        /* activa los keepalives */
        {
                int i=1;

                if(setsockopt(s, SOL_SOCKET, SO_KEEPALIVE,
                        (char *) &i, sizeof(int))==-1)
                        exiterror("setsockopt(SO_KEEPALIVE)",10);
        }

        /* asigna el puerto local en el rango 512-1023 */
        gethostname(localname,sizeof(localname));
        h=gethostbyname(localname);
        memcpy((char *)&local.sin_addr,(char *)h->h_addr,h->h_length);
        local.sin_family=AF_INET;
        local.sin_port=htons(512+(time(NULL)%510));

        if(bind(s,(struct sockaddr *)&local,sizeof(local))==-1)
                exiterror("bind",9);

        if((connect(s,(struct sockaddr *)&server,sizeof(server)))==-1)
                exiterror("connect",4);

        /* construye el comando */
        if(*rfile=='|')
                strcpy(str, &rfile[1]);
        else
        if(to)

#define KIPTOOLS_STYLE
#ifdef KIPTOOLS_STYLE

                sprintf(str,"cat > %s",rfile);
        else
                sprintf(str,"cat %s",rfile);

#else

                sprintf(str,"rcp -t %s",rfile);
        else
                sprintf(str,"rcp -f %s",rfile);

#endif /* ifdef KIPTOOLS_STYLE */

        /* crea el comando RSH y lo enva */
        cmdlen=buildcmd(cmd,username,str);
        send(s,cmd,cmdlen,0);

        if(to)
        {
                /* enva el fichero */
                for(;;)
                {
                        if((l=read(fdes,str,sizeof(str)-1))==0)
                                break;

                        tot=tot+l;
/*                        printf("%lu\r",tot);*/

                        if(send(s,str,l,0)==-1)
                                break;
                }
        }
        else
        {
                /* comprueba el cdigo de respuesta */
                l=recv(s,str,sizeof(str)-1,0);

                if(str[0]=='1')
                {
                        str[l]='\0';

                        printf("Rcp error: %s",&str[1]);
                }
                else
                {
                        write(fdes,str+1,l-1);

                        /* recibe el resto del fichero */
                        for(;;)
                        {
                                if((l=recv(s,str,
                                        sizeof(str)-1,0))<=0)
                                        break;

                                tot=tot+l;
/*                                printf("%lu\r",tot);*/

                                write(fdes,str,l);
                        }
                }
        }

        /* cierra el fichero */
        close(fdes);

        printf("\n");
        sleep(1);

        /* cierra el socket */
        if(closesocket(s)==-1)
                exiterror("close",7);

        end_sockets();
        return(0);
}
