/*

        rlogin.c

        KipTOOLS - (C) Angel Ortega

*/

#include <stdlib.h>

#include "kiptools.h"


/* eco local */

int local_echo=0;


void exiterror(char * msg, int val)
{
        end_sockets();

        printf("%s: %s\n",msg, strerrorsocket());
        exit(val);
}


int main(int argc, char * argv[])
{
        int stype;
        int s;
        struct hostent * h;
        struct sockaddr_in local;
        struct sockaddr_in server;
        int l,n;
        long blocking;
        unsigned char c;
        unsigned char str[4096];
        char * logname;

        printf("\nRlogin (Remote Login) - %s.\n",KIPTOOLS_VERSION);
        printf("  (C) Angel Ortega 1995/1997.\n\n");

        if(argc<2)
        {
                printf("Usage: rlogin {host}\n\n");

                exit(1);
        }

        if(!init_sockets())
                exiterror("init",2);

        /* transforma el IP */
        if((h=gethostbyname(argv[1]))==NULL)
        {
                printf("Error: host '%s' not found.\n", argv[1]);
                exiterror("gethostbyname",2);
        }

        memcpy((char *)&server.sin_addr,(char *)h->h_addr,h->h_length);
        server.sin_family=h->h_addrtype;
        server.sin_port=htons(513);

        /* pide un socket */
        if((s=socket(AF_INET, SOCK_STREAM, 0))==-1)
                exiterror("socket",3);

        /* asigna el puerto local en el rango 512-1023 */
        randomize();
        local.sin_port=htons(512+random(510));

        if(bind(s,&local,sizeof(local))==-1)
                exiterror("bind",9);

        /* conecta */
        if((connect(s,&server,sizeof(server)))==-1)
                exiterror("connect",4);

        /* crea la cadena de identificacin */
        logname=getlogin();
        sprintf(str,"\0%s\0%s\0dumb/38400",logname,logname);

        send(s,str,strlen(logname)*2+4+10, 0);

        /* espera la respuesta */
        recv(s,str,sizeof(str),0);

        if(str[0]!='\0')
        {
                printf("Error: %s\n", &str[1]);

                end_sockets();
                exit(2);
        }

        /* define el socket como no bloqueante */
        blocking=0;

        ioctlsocket(s, FIONBIO, &blocking);

        /* comunica */
        for(;;)
        {
                if(kbhit())
                {
                        c=(unsigned char) getch();

                        if(c==1)
                                break;

                        str[0]=c;
                        n=1;

                        str[n]='\0';

                        if(send(s,str,n,0)==-1)
                                printf("*");

                        if(local_echo)
                                printf(str);
                }

                if((l=recv(s,str,sizeof(str)-1,0))==-1)
                {
                        if(KipErrno!=KIPERR_WOULDBLOCK)
                                break;
                }
                else
                {
                        for(n=0;n<l;n++)
                        {
//                                if(str[n]<128)
                                        putch(str[n]);
                        }
                }

                delay(30);
        }

        /* cierra el socket */
        if(closesocket(s)==-1)
                exiterror("close",7);

        end_sockets();

        return(0);
}
