/*

        RSH.C

        KipTOOLS - (C) Angel Ortega

*/

#include <string.h>
#include <stdlib.h>
#include <time.h>

#include "kiptools.h"

void exiterror(char * msg, int val)
{
        end_sockets();

        printf("%s: %s\n",msg, strerrorsocket());
        exit(val);
}


int buildcmd(char * buf, char * name, char * cmd)
/* construye el comando RSH sobre buf */
/* devuelve la longitud */
{
        strcpy(buf,"0");
        buf+=2;
        strcpy(buf,name);
        buf+=strlen(name)+1;
        strcpy(buf,name);
        buf+=strlen(name)+1;
        strcpy(buf,cmd);

        return(6+strlen(name)*2+strlen(cmd));
}


int main(int argc, char * argv[])
{
        int s;
        struct hostent * h;
        struct sockaddr_in local;
        struct sockaddr_in server;
        char str[4096];
        char cmd[300];
        int cmdlen;
        int l;
        char * hostname;
        char * username;
        char localname[80];

        /* logo */
        printf("\nRSH (Remote Shell) - %s\n",KIPTOOLS_VERSION);
        printf("  (C) Angel Ortega 1995/1997\n\n");

        if(argc!=3)
        {
                printf("Usage: RSH [user@]host command\n");
                exit(0);
        }

        if(!init_sockets())
                exiterror("init_sockets",2);

        /* extrae el usuario y el host */
        if((hostname=strchr(argv[1],'@'))==NULL)
        {
                hostname=argv[1];
                username=(char *)getlogin();
        }
        else
        {
                *hostname='\0';
                hostname++;
                username=argv[1];
        }

        /* transforma el IP */
        if((h=gethostbyname(hostname))==NULL)
        {
                printf("Error: host '%s' not found.\n", hostname);
                exiterror("gethostbyname",2);
        }

        memcpy((char *)&server.sin_addr,(char *)h->h_addr,h->h_length);

        /* rellena la familia y el puerto destino */
        server.sin_family=AF_INET;
        server.sin_port=htons(514);

        /* pide un socket */
        if((s=socket(AF_INET, SOCK_STREAM, 0))==-1)
                exiterror("socket",3);

        /* asigna el puerto local en el rango 512-1023 */
        gethostname(localname,sizeof(localname));
        h=gethostbyname(localname);
        memcpy((char *)&local.sin_addr,(char *)h->h_addr,h->h_length);
        local.sin_family=AF_INET;
        local.sin_port=htons(512+(time(NULL)%510));

        if(bind(s,(struct sockaddr *)&local,sizeof(local))==-1)
                exiterror("bind",9);

        if((connect(s,(struct sockaddr *)&server,sizeof(server)))==-1)
                exiterror("connect",4);

        /* construye el comando */
        cmdlen=buildcmd(cmd,username,argv[2]);

        /* lo enva */
        send(s,cmd,cmdlen,0);

        /* espera la respuesta */
        for(;;)
        {
                if((l=recv(s,str,sizeof(str)-1,0))<=0)
                        break;

                str[l]=0;

                if(str[0]=='1')
                        printf("Rsh error: %s\n", &str[1]);
                else
                        printf("%s",str);
        }

        /* cierra el socket */
        if(closesocket(s)==-1)
                exiterror("close",7);

        end_sockets();

        return(0);
}
