/*

        rshd.c

        KipTOOLS - (C) Angel Ortega

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#include "kiptools.h"

struct sockaddr_in server;
struct sockaddr_in client;

char buffer[512];


/******************
        code
*******************/

void exiterror(char * msg, int val)
{
        end_sockets();

        printf("%s: %s\n",msg, strerrorsocket());
        exit(val);
}


void rshd_shell(int c)
/* ejecuta el comando */
{
        int size;
        int serr;
        int serrport;
        struct sockaddr_in client2;
        char * cliuser;
        char * srvuser;
        char * cmd;
        char cmd2[1024];
        FILE * f;
        int do_read;
        int tot;

        size=recv(c,buffer,sizeof(buffer),0);

        if((serrport=atoi(buffer))!=0)
        {
                serr=socket(AF_INET, SOCK_STREAM, 0);

                /* hace el bind en un puerto reservado */
                memcpy(&client2,&server,sizeof(client2));
                client2.sin_port=htons(serrport+1);

                bind(serr,(struct sockaddr *)&client2, sizeof(client2));

                /* hace el connect */
                memcpy(&client2,&client,sizeof(client2));
                client2.sin_port=htons(serrport);

                connect(serr,(struct sockaddr *)&client2,sizeof(client2));
        }
        else
                serr=0;

        /* comprueba si ha llegado todo en un slo paquete */
        if(strlen(buffer)+1==size)
        {
                /* slo ha llegado el puerto:
                   leer otro buffer */
                size=recv(c,buffer,sizeof(buffer),0);
                cliuser=buffer;
        }
        else
        {
                /* localizar el usuario */
                for(cliuser=buffer;*cliuser;cliuser++); cliuser++;
        }

        for(srvuser=cliuser;*srvuser;srvuser++); srvuser++;
        for(cmd=srvuser;*cmd;cmd++); cmd++;

        printf("\nrshd: port==%d, cliuser=='%s', srvuser=='%s', cmd=='%s'\n",
                serrport,cliuser,srvuser,cmd);

        /* casos especiales */
        if(memcmp(cmd,"rcp -t ",7)==0)
        {
                /* recepcin de fichero mediante rcp */
                do_read=0;

                f=fopen(&cmd[7],"wb");

                printf("- Receiving %s\n",&cmd[7]);
        }
        else
        if(memcmp(cmd,"cat > ",6)==0)
        {
                /* recepcin de fichero mediante KipTOOLS rcp */
                do_read=0;

                f=fopen(&cmd[6],"wb");

                printf("- Receiving %s\n",&cmd[6]);
        }
        else
        if(memcmp(cmd,"rcp -f ",7)==0)
        {
                /* envo de fichero mediante rcp standard */
                do_read=1;

                if((f=fopen(&cmd[7],"rb"))==NULL)
                {
                        send(c,"1error1",7,0);
                        return;
                }

                printf("- Sending %s\n",&cmd[7]);
        }
        else
        if(memcmp(cmd,"cat ",4)==0)
        {
                /* envo de fichero mediante KipTOOLS rcp */
                do_read=1;

                if((f=fopen(&cmd[4],"rb"))==NULL)
                {
                        send(c,"1error2",7,0);
                        return;
                }

                printf("- Sending %s\n",&cmd[4]);
        }
        else
        {
                /* ejecucin normal */

                unlink("rshd.tmp");
                sprintf(cmd2,"%s > rshd.tmp",cmd);

                system(cmd2);

                if((f=fopen("rshd.tmp","rb"))==NULL)
                {
                        send(c,"1error3",7,0);
                        return;
                }

                do_read=1;
        }

        if(do_read)
        {
                /* valida */
                send(c,"0",1,0);

                tot=0;

                for(;;)
                {
                        size=fread(buffer,1,sizeof(buffer),f);

                        if(size==0)
                                break;

                        send(c,buffer,size,0);

                        tot+=size;
                        printf("- snd %d\r",tot);
                }

                fclose(f);
        }
        else
        {
                /* escritura */
                send(c,"0",1,0);

                tot=0;

                for(;;)
                {
                        size=recv(c,buffer,sizeof(buffer),0);

                        if(size<=0)
                                break;

                        fwrite(buffer,1,sizeof(buffer),f);

                        tot+=size;
                        printf("- rcv %d\r",tot);
                }

                fclose(f);
        }

        sleep(1);

        printf("- Done.--------------------------\n");
}


int main(int argc, char * argv[])
{
        int s,c;
        int n;
        struct hostent * h;
        char localhost[100];
        int size;

        /* logo */
        printf("\nRSHD (Remote Shell Daemon) - %s\n",KIPTOOLS_VERSION);
        printf("  (C) Angel Ortega 1998\n\n");

        if(!init_sockets())
                exiterror("init_sockets",2);

        gethostname(localhost,sizeof(localhost));

        if((h=gethostbyname(localhost))==NULL)
                exiterror("gethostbyname",4);

        memcpy((char *)&server.sin_addr,(char *)h->h_addr,h->h_length);
        server.sin_family=h->h_addrtype;
        server.sin_port=htons(514);

        if((s=socket(AF_INET,SOCK_STREAM,0))==-1)
                exiterror("socket",2);

        if(bind(s,(struct sockaddr *)&server,sizeof(server))==-1)
                exiterror("bind",3);

        getsockname(s,(struct sockaddr *)&server,&n);
        printf("[%s:%d]\n",inet_ntoa(server.sin_addr),
                ntohs(server.sin_port));

        listen(s,5);

        for(;;)
        {
                size=sizeof(struct sockaddr);

                if((c=accept(s,(struct sockaddr *)&client,&size))==-1)
                        exiterror("accept",5);

                rshd_shell(c);

                closesocket(c);
        }

        closesocket(s);

        end_sockets();

        return(0);
}
