/*

        systime.c

        Hace una peticin daytime por UDP
        y actualiza el reloj en consecuencia.

        Librera KIP.

        (C) Angel Ortega

*/

#include <dos.h>
#include <string.h>

#include "kip.h"


void Daytimed(void);


/* los meses en ingls */
char * meseseng[]=
{
"Jan", "Feb", "Mar", "Apr", "May", "Jun",
"Jul", "Aug", "Sep", "Oct", "Nov", "Dec", NULL
};


void exiterror(char * msg, int val)
{
        EndKIP();

        printf("%s: %s\n",msg, StrErrorKIP());
        exit(val);
}


void Update(char * str)
/* actualiza la fecha */
{
        char * ptr;
        union REGS sdate;
        union REGS stime;
        int n;

        /* el formato es 'Sun Oct 29 14:41:32 1995' */

        /* salta el da de la semana */
        strtok(str, " ");

        /* coge el mes */
        ptr=strtok(NULL," ");

        for(n=0;meseseng[n]!=NULL;n++)
        {
                if(strcmp(meseseng[n],ptr)==0)
                        break;
        }

        sdate.h.dh=n+1;

        /* da del mes */
        sdate.h.dl=atoi(strtok(NULL," "));

        /* horas */
        stime.h.ch=atoi(strtok(NULL,":"));

        /* minutos */
        stime.h.cl=atoi(strtok(NULL,":"));

        /* segundos */
        stime.h.dh=atoi(strtok(NULL," "));

        /* ao */
        sdate.x.cx=atoi(strtok(NULL," "));

        sdate.h.ah=0x2b;
        int86(0x21,&sdate,&sdate);

        stime.h.ah=0x2d;
        int86(0x21,&stime,&stime);
}


int main(int argc, char * argv[])
{
        int s;
        struct hostent * h;
        struct sockaddr_in server;
        char str[1024];
        int l;

        printf("Systime - sincroniza el reloj con el remoto. Librera KIP.\n");
        printf("  (C) Angel Ortega 1995/1996.\n\n");

        if(argc!=2)
        {
                printf("Uso: systime {host}\n\n");

                exit(1);
        }

        if(!InitKIP())
                exiterror("InitKIP",2);

        /* transforma el IP */
        if((h=gethostbyname(argv[1]))==NULL)
        {
                printf("Error: host '%s' no encontrado.\n", argv[1]);
                exiterror("GetHostByName",2);
        }

        memcpy((char *)&server.sin_addr,(char *)h->h_addr,h->h_length);

        Daytimed();

        /* rellena la familia y el puerto destino */
        server.sin_family=AF_INET;
        server.sin_port=htons(13); //13

        /* pide un socket */
        if((s=socket(AF_INET, SOCK_DGRAM, 0))==-1)
                exiterror("Socket",3);

        /* hace la conexin con el server */
        if((connect(s,&server,sizeof(server)))==-1)
                exiterror("ConnectSocket",4);

        /* enva algo por el puerto */
        if((send(s,0,0,0))==-1)
                exiterror("SendSocket",5);

        /* espera la respuesta */
        if((l=recv(s,str,sizeof(str)-1,0))==-1)
                exiterror("RecvSocket",6);

        str[l]=0;
        printf("%s",str);

        /* cierra el socket */
        if(closesocket(s)==-1)
                exiterror("CloseSocket",7);

        EndKIP();

        Update(str);

        return(0);
}
